//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include "u_pass.h"
#include "u_sortlist.h"
#include "u_locate.h"
#include "u_about.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "FIBExTreeComboBox"
#pragma link "FIBExTreeList"
#pragma link "FIBExTreeView"
#pragma link "ImageComboBox"
#pragma link "FIBDatabase"
#pragma link "FIBDataSet"
#pragma link "ImageComboBox"
#pragma link "pFIBDatabase"
#pragma link "pFIBDataSet"
#pragma link "FIBExTreeColumnList"
#pragma link "FIBExTrees"
#pragma link "FIBExDynTreeColumnList"
#pragma link "FIBExDynTreeComboBox"
#pragma link "FIBExDynTreeList"
#pragma link "FIBExDynTreeView"
#pragma resource "*.dfm"

TF_main *F_main;
AnsiString DemoDataBasePath;

//---------------------------------------------------------------------------
__fastcall TF_main::TF_main(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TF_main::Exit1Click(TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FormActivate(TObject *Sender)
{
 if (!IBD->Connected)
    while(1)
    {
      try
      {
         // correct this path for demo.gdb !!!
         AnsiString PATH = ExtractFilePath(Application->ExeName);
         AnsiString TEST = "base//demo.gdb";
         if (!FileExists(PATH+TEST)) {
            AnsiString CUR = "CBuilder";
            PATH = PATH.SubString(0, PATH.Length()-CUR.Length()-1);
         }
         PATH = PATH + TEST;
         if (!FileExists(PATH)) {
            if (!OD->Execute()) { Close(); break; }
            PATH = OD->FileName;
         }
         DemoDataBasePath = "localhost:"+ PATH;

         if (IBD->Connected) IBD->Connected = FALSE;
         IBD->DatabaseName = DemoDataBasePath;
         IBD->DBParams->Clear();
         IBD->DBParams->Add("USER_NAME=SYSDBA");
         if (F_pass->ShowModal() == mrOk)
         {
           IBD->DBParams->Add("PASSWORD="+F_pass->Edit1->Text);
           IBD->Connected = TRUE;
           FIBExTreeView1->BuildTree(0); // read all nodes of tree
           FIBExTreeView1->SetFocus();
         } else Close();
         break;
      } catch (...) {
            if (Application->MessageBox(
            "Could not open Database: correct SYSDBA password - Try again?",
            "Open Error Database",
            MB_OKCANCEL + MB_DEFBUTTON1) != IDOK)
            {
              Close();
              break;
            }
      }
    }
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FormShow(TObject *Sender)
{
 ComboBox1->ItemIndex = 0;
 ComboBox3->ItemIndex = 0;
 ComboBox5->ItemIndex = 0;
 ComboBox6->ItemIndex = 0;
 ComboBox8->ItemIndex = 0;
 ComboLevels->ItemIndex = FIBExTreeView1->VisibleLevels;
 ComboLLevels->ItemIndex = FIBExTreeColumnList1->VisibleLevels;
 ComboBLevels->ItemIndex = FIBExTreeComboBox1->VisibleLevels;
 ComboFilter->ItemIndex = 0;
 ComboLFilter->ItemIndex = 0;
 ComboCFilter->ItemIndex = 0;
 ImageComboBox1->ItemIndex = -1;
  //////////////////////////////////////////////////////
 AutoCheckChildren->Checked=FIBExTreeView1->TreeCheckOptions->AutoCheckChildren;
 AutoUnCheckChildren->Checked=FIBExTreeView1->TreeCheckOptions->AutoUnCheckChildren;
 AutoCheckParents->Checked=FIBExTreeView1->TreeCheckOptions->AutoCheckParents;
 AutoUnCheckParents->Checked=FIBExTreeView1->TreeCheckOptions->AutoUnCheckParents;
 //////////////////////////////////////////////////////
 DisableRG=False;
 PageTrees->ActivePageIndex = 0;
 PageTreesChange(NULL);
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FormClose(TObject *Sender, TCloseAction &Action)
{
  if (IBDataSet1->Active) IBDataSet1->Close();
  if (IBD->Connected) IBD->Connected = false;
}
//---------------------------------------------------------------------------

void __fastcall TF_main::PageTreesChange(TObject *Sender)
{
  if (PageTrees->ActivePageIndex == 0) {
     Edit1->Visible=True;
     Option1->Visible=True;
     View1->Visible=True;
     PageControl1->ActivePageIndex=0;
     if (IBD->Connected) PageControl1Change(NULL);
  } else {
     Edit1->Visible=False;
     Option1->Visible=False;
     View1->Visible=False;
     PageDynControl->ActivePageIndex=0;
     if (IBD->Connected) PageDynControlChange(NULL);
  }
}

//---------------------------------------------------------------------------

void __fastcall TF_main::PageControl1Change(TObject *Sender)
{
  switch (PageControl1->ActivePageIndex) {
  case 0:
        TB_FILTER->Down = false;
        FIBExTreeView1->BuildTree(0);
        FIBExTreeView1->SetFocus();
        break;
  case 1:
        FIBExTreeColumnList1->Tree->BuildTree(0);
        FIBExTreeColumnList1->SetFocus();
        break;
  case 2:
        FIBExTreeView4->BuildTree(0);
        FIBExTreeList1->BuildList(0);
        TB_LARGE->Down = true;
        TB_LARGE->Click();
        break;
  case 3:
        FIBExTreeView5->BuildTree(0);
        FIBExTreeView5->SetFocus();
        RadioGroup1->ItemIndex = 1;
        CheckBox1->Checked=false;
        CheckBox2->Checked=false;
        CheckBox3->Checked=true;
        CheckBox4->Checked=false;
        CheckBox5->Checked=true;
        FIBExTreeComboBox1->KeyValue = 0;
        FIBExTreeComboBox1ChangeKeyValue(Sender);
        break;
  case 4:
        FIBExTreeView2->BuildTree(0);
        FIBExTreeView3->BuildTree(0);
        FIBExTreeView2->SetFocus();
        break;
  case 5:
        if (IBDataSet1->Active) IBDataSet1->Close();
        B_CREATEDATA->Visible = true;
        CheckBox6->Checked = false;
        FIBExTreeView6->BuildTree(0);
        FIBExTreeView6->SetFocus();
        break;
  case 6:
        if (IBDataSet2->Active) IBDataSet2->Close();
        IBDataSet2->Open();
  }
  for (int i = 1; i < 4; i++)
  MainMenu1->Items->Items[i]->Enabled = (PageControl1->ActivePageIndex == 0);
}

//////////////////////////////////////////////////////////////////////////////
///////////////////////////// FIBExTreeView //////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

//-------------------------------Add item-------------------------------------

void __fastcall TF_main::TB_ADDITEMClick(TObject *Sender)
{
  if (FIBExTreeView1->Items->Count == 0)
     FIBExTreeView1->InsertNode(0,"NewNode");
  else
  {
     TestSelected(FIBExTreeView1);
     FIBExTreeView1->InsertNode(FIBExTreeView1->Selected->Parent,"NewNode");
  }
  FIBExTreeView1->SetFocus();
}
//-------------------------------Add child-------------------------------------

void __fastcall TF_main::TB_ADDCHILDClick(TObject *Sender)
{
  TestSelected(FIBExTreeView1);
  FIBExTreeView1->InsertNode(FIBExTreeView1->Selected,"NewNode");
  FIBExTreeView1->SetFocus();
}
//----------------------------Delete item-------------------------------------

void __fastcall TF_main::TB_DELETEClick(TObject *Sender)
{
  TestSelected(FIBExTreeView1);
  FIBExTreeView1->DeleteNode(FIBExTreeView1->Selected);
  FIBExTreeView1->SetFocus();
}
//-----------------------------Edit item-----------------------------------

void __fastcall TF_main::TB_EDITClick(TObject *Sender)
{
  TestSelected(FIBExTreeView1);
  FIBExTreeView1->Selected->EditText();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FIBExTreeView1BeforeDeleteNode(TObject *Sender,
      TTreeNode *Node, bool &AllowDelete)
{
  AllowDelete = (MessageDlg("Delete selected item?",mtConfirmation,
                 TMsgDlgButtons() << mbOK << mbCancel,0) == mrOk);
}
//----------------Custom Sort Items: 'SORTINDEX' field used------------------

void __fastcall TF_main::TB_SORTClick(TObject *Sender)
{
  TestSelected(FIBExTreeView1);
  FIBExTreeView1->GetOrderNodes(FIBExTreeView1->Selected,F_sortlist->ListBox1->Items);
  if (F_sortlist->ShowModal() == mrOk)
  FIBExTreeView1->ReorderNodes(FIBExTreeView1->Selected,F_sortlist->ListBox1->Items);
  FIBExTreeView1->SetFocus();
}
//----------------------------Move one up-------------------------------------

void __fastcall TF_main::TB_UPClick(TObject *Sender)
{
  TestSelected(FIBExTreeView1);
  TTreeNode* TestNode = FIBExTreeView1->Selected->getPrevSibling();
  if (TestNode != NULL) FIBExTreeView1->ExchangeNode(FIBExTreeView1->Selected, TestNode);
}
//----------------------------Move one down-----------------------------------

void __fastcall TF_main::TB_DNClick(TObject *Sender)
{
  TTreeNode* TestNode = FIBExTreeView1->Selected->getNextSibling();
  if (TestNode != NULL)
  FIBExTreeView1->ExchangeNode(FIBExTreeView1->Selected, TestNode);
}
//---------------------------Move one up level--------------------------------

void __fastcall TF_main::TB_TOP1Click(TObject *Sender)
{
  TestSelected(FIBExTreeView1);
  if (FIBExTreeView1->Selected->Parent != NULL)
  FIBExTreeView1->MoveNode(FIBExTreeView1, FIBExTreeView1->Selected,
                           FIBExTreeView1->Selected->Parent->Parent, true);
}
//--------------------------Move one down level-------------------------------

void __fastcall TF_main::TB_DOWNClick(TObject *Sender)
{
  TestSelected(FIBExTreeView1);
  TTreeNode* DestNode = FIBExTreeView1->Selected->getPrevSibling();
  if ((DestNode != NULL) && (DestNode != FIBExTreeView1->Selected->Parent))
  FIBExTreeView1->MoveNode(FIBExTreeView1, FIBExTreeView1->Selected, DestNode, true);
}
//-------------------------UpdateStateCheckButtons----------------------------


void __fastcall TF_main::UpdateTreeStateCheckButtons(void)
{
  TB_CHECLALL->Enabled = (FIBExTreeView1->TreeStyle == tsCheckBox);
  TB_UNCHECLALL->Enabled = (FIBExTreeView1->TreeStyle == tsCheckBox);
  DisableCheck->Enabled = (FIBExTreeView1->TreeStyle !=tsSimple);
  AutoCheckChildren->Enabled = (FIBExTreeView1->TreeStyle == tsCheckBox);
  AutoUnCheckChildren->Enabled = (FIBExTreeView1->TreeStyle == tsCheckBox);
  AutoCheckParents->Enabled = (FIBExTreeView1->TreeStyle == tsCheckBox);
  AutoUnCheckParents->Enabled = (FIBExTreeView1->TreeStyle == tsCheckBox);
  ImageComboBox1->Enabled = (FIBExTreeView1->TreeStyle != tsCheckBox);
  Checkallitems->Enabled = TB_CHECLALL->Enabled;
  Uncheckallitems->Enabled = TB_UNCHECLALL->Enabled;
  Memo1->Visible = (FIBExTreeView1->TreeStyle !=tsSimple);
}
//--------------Set CheckBox mode - it call BuildTree---------------------------

void __fastcall TF_main::ComboBox1Change(TObject *Sender)
{
  if (ComboBox1 -> Text == "Simple")
      FIBExTreeView1->TreeStyle = tsSimple;
  else
  if (ComboBox1 -> Text == "CheckBox")
      FIBExTreeView1->TreeStyle = tsCheckBox;
  else
      FIBExTreeView1->TreeStyle = tsRadioGroup;
  UpdateTreeStateCheckButtons();
  FIBExTreeView1->SetFocus();        
}
//---------------------------------------------------------------------------

void __fastcall TF_main::ComboBox2Change(TObject *Sender)
{
  if (FIBExTreeView1->TreeStyle != tsSimple) FIBExTreeView1->BuildTree(0);
  UpdateTreeStateCheckButtons();
  FIBExTreeView1->SetFocus();
}
//--------------------------------------------------------------------------

void __fastcall TF_main::ComboLevelsChange(TObject *Sender)
{
  FIBExTreeView1->VisibleLevels = ComboLevels->ItemIndex;
  FIBExTreeView1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::ComboFilterChange(TObject *Sender)
{
  switch (ComboFilter->ItemIndex){
    case 0: FIBExTreeView1->Filtered = False;
            break;
    case 1: FIBExTreeView1->Filter = "NAME starting with '"+Trim(E_FILTER->Text)+"'";
            if (! FIBExTreeView1->Filtered) FIBExTreeView1->Filtered = True;
            break;
    case 2: FIBExTreeView1->Filter = "NAME containing '"+Trim(E_FILTER->Text)+"'";
            if (! FIBExTreeView1->Filtered) FIBExTreeView1->Filtered = True;
  }
  // Note: If property Filtered == True and property Filter is not empty and was changed or
  //       property Filter is not empty and property Filtered was changed to true then
  //       TreeView will be rebuild automatically!
}
//---------------------------------------------------------------------------

void __fastcall TF_main::E_FILTERKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  if ((Key == VK_RETURN) && FIBExTreeView1->Filtered) ComboFilterChange(0);
}
//---------------------------------------------------------------------------

void __fastcall TF_main::DisableCheckClick(TObject *Sender)
{
  DisableCheck->Checked = !DisableCheck->Checked;
}
//--------------------Set "Read Only" checkboxes----------------------------

void __fastcall TF_main::FIBExTreeView1BeforeCheck(TObject *Sender,
      TTreeNode *Node, bool &AllowChecked)
{
   AllowChecked = !DisableCheck->Checked;
}
//--------------------------Chek all items---------------------------------

void __fastcall TF_main::TB_CHECLALLClick(TObject *Sender)
{
  FIBExTreeView1->CheckAllNodes();
  FIBExTreeView1AfterCheck(Sender, NULL, false);
  FIBExTreeView1->SetFocus();
}
//-------------------------UnChek all items---------------------------------

void __fastcall TF_main::TB_UNCHECLALLClick(TObject *Sender)
{
  FIBExTreeView1->UnCheckAllNodes();
  FIBExTreeView1AfterCheck(Sender, NULL, false);
  FIBExTreeView1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::ComboLFilterChange(TObject *Sender)
{
  switch (ComboLFilter->ItemIndex){
    case 0: FIBExTreeColumnList1->Filtered = False;
            break;
    case 1: FIBExTreeColumnList1->Filter = "NAME starting with '"+Trim(E_LFILTER->Text)+"'";
            if (! FIBExTreeColumnList1->Filtered) FIBExTreeColumnList1->Filtered = True;
            break;
    case 2: FIBExTreeColumnList1->Filter = "NAME containing '"+Trim(E_LFILTER->Text)+"'";
            if (! FIBExTreeColumnList1->Filtered) FIBExTreeColumnList1->Filtered = True;
  }
  // Note: If property Filtered = True and property Filter is not empty and was changed or
  //       property Filter is not empty and property Filtered was changed to true then
  //       TreeView will be rebuild automatically!
}
//---------------------------------------------------------------------------

void __fastcall TF_main::E_LFILTERKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  if ((Key == VK_RETURN) && FIBExTreeColumnList1->Filtered) ComboLFilterChange(0);
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FIBExTreeView1AfterCheck(TObject *Sender,
      TTreeNode *Node, bool Checked)
{
  if (FIBExTreeView1->TreeStyle != tsSimple){
     Memo1->Lines->BeginUpdate();
     Memo1->Lines->Clear();
     Memo1->Lines->Add("CheckList in memory:");
     for (int i=0; i< FIBExTreeView1->CheckCount; i++)
         Memo1->Lines->Add(IntToStr(FIBExTreeView1->GetCheckID(i)));
     Memo1->Lines->EndUpdate();
  }
}

//---------------------------FullCollapse----------------------------------

void __fastcall TF_main::TB_COLLAPSEClick(TObject *Sender)
{
  FIBExTreeView1->FullCollapse();
  FIBExTreeView1->SetFocus();
  if (FIBExTreeView1->Items->Count != 0)
     (FIBExTreeView1->Items->operator [](0))->Selected = True;
}
//---------------------------FullExpand-----------------------------------

void __fastcall TF_main::TB_EXPANDClick(TObject *Sender)
{
  FIBExTreeView1->FullExpand();
  FIBExTreeView1->SetFocus();        
}
//----------Filter children for parend id (Set FilterID = parend id)---------

void __fastcall TF_main::TB_FILTERClick(TObject *Sender)
{
 if (TB_FILTER->Down)
     try
     {
       TestSelected(FIBExTreeView1);
       String SelName = FIBExTreeView1->GetName(FIBExTreeView1->Selected);
       FIBExTreeView1->BuildTree(FIBExTreeView1->GetId(FIBExTreeView1->Selected));
       ShowMessage("Filter for   "+SelName+
                   "   (FilterID ="+IntToStr(FIBExTreeView1->FilterID)+")");
     } catch(...){
       TB_FILTER->Down = False;
       throw;
     }
  else FIBExTreeView1->BuildTree(0);
  FIBExTreeView1->SetFocus();
  if (FIBExTreeView1->Items->Count != 0)
      FIBExTreeView1->Items->operator[](0)->Selected = True;
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FIBExTreeView1Change(TObject *Sender,
      TTreeNode *Node)
{
// you my use this event for select data from relations tables //
  FIBExTreeView1AfterUpdateImage(Sender, Node);
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FIBExTreeView1AfterUpdateImage(TObject *Sender,
      TTreeNode *Node)
{
    if (FIBExTreeView1->Images != NULL) {
       if (Node->ImageIndex < ImageComboBox1->Items->Count-1)
          ImageComboBox1->ItemIndex = Node->ImageIndex;
       else
          ImageComboBox1->ItemIndex = -1;
    } else ImageComboBox1->ItemIndex = -1;
    if (FIBExTreeView1->StateImages != NULL) {
       if (Node->StateIndex < ImageComboBox2->Items->Count - 1)
          ImageComboBox2->ItemIndex = Node->StateIndex-1;
       else
          ImageComboBox2->ItemIndex = -1;
    }  else ImageComboBox2->ItemIndex = -1;
    FIBExTreeView1->SetFocus();
}
//---------------------------------------------------------------------------


void __fastcall TF_main::EditItemsafterInsertClick(TObject *Sender)
{
  EditItemsafterInsert->Checked = !EditItemsafterInsert->Checked;
  FIBExTreeView1->TreeEditOptions->EditAfterInsert = EditItemsafterInsert->Checked;        
}
//---------------------------------------------------------------------------

void __fastcall TF_main::UpdateImagelevelClick(TObject *Sender)
{
  UpdateImagelevel->Checked = !UpdateImagelevel->Checked;
  FIBExTreeView1->TreeEditOptions->UpdateImagesLevel = UpdateImagelevel->Checked;        
}
//---------------------------------------------------------------------------

void __fastcall TF_main::ImageComboBox1Change(TObject *Sender)
{
 if (FIBExTreeView1->Selected != NULL){
    FIBExTreeView1->UpdateImageIndex(FIBExTreeView1->Selected,ImageComboBox1->ItemIndex);
    FIBExTreeView1Change(Sender, FIBExTreeView1->Selected);
 }
}
//---------------------------------------------------------------------------

void __fastcall TF_main::ImageComboBox2Change(TObject *Sender)
{
 if (FIBExTreeView1->Selected != NULL){
     FIBExTreeView1->UpdateStateIndex(FIBExTreeView1->Selected,ImageComboBox2->ItemIndex+1);
     FIBExTreeView1Change(Sender, FIBExTreeView1->Selected);
 }
}
//---------------------------------------------------------------------------

void __fastcall TF_main::OpHideImagesClick(TObject *Sender)
{
  OpHideImages->Checked = !OpHideImages->Checked;
  if (FIBExTreeView1->Images != NULL)
     FIBExTreeView1->Images = NULL;
  else
     FIBExTreeView1->Images = ImageTree;
  FIBExTreeView1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::OpHideStateImagesClick(TObject *Sender)
{
  OpHideStateImages->Checked = !OpHideStateImages->Checked;
  if (FIBExTreeView1->StateImages != NULL)
     FIBExTreeView1->StateImages = NULL;
  else
     FIBExTreeView1->StateImages = ImageState;
  FIBExTreeView1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::OpShowFieldIDClick(TObject *Sender)
{
  OpShowFieldID->Checked = ! OpShowFieldID->Checked;
  FIBExTreeView1->ShowID = OpShowFieldID->Checked; // it call BuildTree
  FIBExTreeView1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::AutoCheckChildrenClick(TObject *Sender)
{
  AutoCheckChildren->Checked = ! AutoCheckChildren->Checked;
  FIBExTreeView1->TreeCheckOptions->AutoCheckChildren = AutoCheckChildren->Checked;
}

//---------------------------------------------------------------------------
void __fastcall TF_main::AutoUnCheckChildrenClick(TObject *Sender)
{
  AutoUnCheckChildren->Checked = ! AutoUnCheckChildren->Checked;
  FIBExTreeView1->TreeCheckOptions->AutoUnCheckChildren = AutoUnCheckChildren->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TF_main::AutoCheckParentsClick(TObject *Sender)
{
  AutoCheckParents->Checked = ! AutoCheckParents->Checked;
  FIBExTreeView1->TreeCheckOptions->AutoCheckParents = AutoCheckParents->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TF_main::AutoUnCheckParentsClick(TObject *Sender)
{
  AutoUnCheckParents->Checked = ! AutoUnCheckParents->Checked;
  FIBExTreeView1->TreeCheckOptions->AutoUnCheckParents = AutoUnCheckParents->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TF_main::HideTreePopUpImages1Click(TObject *Sender)
{
  HideTreePopUpImages1->Checked = !HideTreePopUpImages1->Checked;
  FIBExTreeView1->HideTreePopUpImages = HideTreePopUpImages1->Checked;
  FIBExTreeView1->RefreshTree();
}

///////////////////////////////////////////////////////////////////////////////
//////////////////////////////// Locate ///////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

bool __fastcall TF_main::Locate(String Val, int LType, int LMode)
{
bool Result;
TFIBExTreeView *TestTree;
    if (PageControl1->ActivePageIndex == 0)
       TestTree=FIBExTreeView1;
    else
       TestTree=FIBExTreeColumnList1->Tree;
    if (LType == 0){
       switch(LMode){
       case 0: {
                Result = (TestTree->LocateName(Val,ltStart) != NULL);
                break;
               }
       case 1: {
                Result = (TestTree->LocateName(Val,ltContaining) != NULL);
                break;
               }
       case 2:  Result = (TestTree->LocateName(Val)!= NULL);

       }
    } else Result = (TestTree->LocateId(StrToInt(Val)) != NULL);
  if (Result) return True;
  else {
    ShowMessage("Not Found!");
    return False;
  }
}
//---------------------------------------------------------------------------

bool __fastcall TF_main::LocateNext(void)
{
TFIBExTreeView *TestTree;
if (PageControl1->ActivePageIndex == 0)
    TestTree=FIBExTreeView1;
else
    TestTree=FIBExTreeColumnList1->Tree;
    
bool Result = (TestTree->LocateNextName() != NULL);
       if (Result) return True;
       else {
         ShowMessage("Not Found more!");
         return False;
       }
}

///////////////////////////////////////////////////////////////////////////////
////////////////////////// FIBExTreeColumnList ////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

void __fastcall TF_main::TBL_ADDITEMClick(TObject *Sender)
{
 if (FIBExTreeColumnList1->Tree->Items->Count == 0)
     FIBExTreeColumnList1->Tree->InsertNode(0,"NewNode");
  else
  {
     TestSelected(FIBExTreeColumnList1->Tree);
     FIBExTreeColumnList1->Tree->InsertNode(FIBExTreeColumnList1->Tree->Selected->Parent,"NewNode");
  }
  FIBExTreeColumnList1->Tree->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::TBL_ADDCHILDClick(TObject *Sender)
{
  TestSelected(FIBExTreeColumnList1->Tree);
  FIBExTreeColumnList1->Tree->InsertNode(FIBExTreeColumnList1->Tree->Selected,"NewNode");
  FIBExTreeColumnList1->Tree->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::TBL_EDITClick(TObject *Sender)
{
  TestSelected(FIBExTreeColumnList1->Tree);
  FIBExTreeColumnList1->Tree->Selected->EditText();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::TBL_DELETEClick(TObject *Sender)
{
  TestSelected(FIBExTreeColumnList1->Tree);
  FIBExTreeColumnList1->Tree->DeleteNode(FIBExTreeColumnList1->Tree->Selected);
  FIBExTreeColumnList1->Tree->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::ImageComboBox3Change(TObject *Sender)
{
 if (FIBExTreeColumnList1->Tree->Selected != NULL){
    FIBExTreeColumnList1->Tree->UpdateImageIndex(FIBExTreeColumnList1->Tree->Selected,ImageComboBox3->ItemIndex);
    FIBExTreeColumnList1Change(Sender, FIBExTreeColumnList1->Tree->Selected);
 }
}
//---------------------------------------------------------------------------

void __fastcall TF_main::ImageComboBox4Change(TObject *Sender)
{
 if (FIBExTreeColumnList1->Tree->Selected != NULL){
     FIBExTreeColumnList1->Tree->UpdateStateIndex(FIBExTreeColumnList1->Tree->Selected,ImageComboBox4->ItemIndex+1);
     FIBExTreeColumnList1Change(Sender, FIBExTreeColumnList1->Tree->Selected);
 }
}
//---------------------------------------------------------------------------

void __fastcall TF_main::TBL_SORTClick(TObject *Sender)
{
  TestSelected(FIBExTreeColumnList1->Tree);
  FIBExTreeColumnList1->Tree->GetOrderNodes(FIBExTreeColumnList1->Tree->Selected,F_sortlist->ListBox1->Items);
  if (F_sortlist->ShowModal() == mrOk)
  FIBExTreeColumnList1->Tree->ReorderNodes(FIBExTreeColumnList1->Tree->Selected,F_sortlist->ListBox1->Items);
  FIBExTreeColumnList1->Tree->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::TBL_UPClick(TObject *Sender)
{
  TestSelected(FIBExTreeColumnList1->Tree);
  TTreeNode* TestNode = FIBExTreeColumnList1->Tree->Selected->getPrevSibling();
  if (TestNode != NULL) FIBExTreeColumnList1->Tree->ExchangeNode(FIBExTreeColumnList1->Tree->Selected, TestNode);
}
//---------------------------------------------------------------------------

void __fastcall TF_main::TBL_DNClick(TObject *Sender)
{
  TTreeNode* TestNode = FIBExTreeColumnList1->Tree->Selected->getNextSibling();
  if (TestNode != NULL)
  FIBExTreeColumnList1->Tree->ExchangeNode(FIBExTreeColumnList1->Tree->Selected, TestNode);
}
//---------------------------------------------------------------------------

void __fastcall TF_main::TBL_TOPClick(TObject *Sender)
{
  TestSelected(FIBExTreeColumnList1->Tree);
  if (FIBExTreeColumnList1->Tree->Selected->Parent != NULL)
  FIBExTreeColumnList1->Tree->MoveNode(FIBExTreeColumnList1->Tree, FIBExTreeColumnList1->Tree->Selected,
                           FIBExTreeColumnList1->Tree->Selected->Parent->Parent, true);
}
//---------------------------------------------------------------------------

void __fastcall TF_main::TBL_DOWNClick(TObject *Sender)
{
  TestSelected(FIBExTreeColumnList1->Tree);
  TTreeNode* DestNode = FIBExTreeColumnList1->Tree->Selected->getPrevSibling();
  if ((DestNode != NULL) && (DestNode != FIBExTreeColumnList1->Tree->Selected->Parent))
  FIBExTreeColumnList1->Tree->MoveNode(FIBExTreeColumnList1->Tree, FIBExTreeColumnList1->Tree->Selected, DestNode, true);
}
//---------------------------------------------------------------------------

void __fastcall TF_main::TBL_COLLAPSEClick(TObject *Sender)
{
  FIBExTreeColumnList1->Tree->FullCollapse();
  FIBExTreeColumnList1->SetFocus();
  if (FIBExTreeColumnList1->Tree->Items->Count != 0)
     (FIBExTreeColumnList1->Tree->Items->operator [](0))->Selected = True;
}
//---------------------------------------------------------------------------

void __fastcall TF_main::TBL_EXPANDClick(TObject *Sender)
{
  FIBExTreeColumnList1->Tree->FullExpand();
  FIBExTreeColumnList1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::TBL_LOCATEClick(TObject *Sender)
{
  F_locate->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FIBExTreeColumnList1Change(TObject *Sender,
      TTreeNode *Node)
{
  FIBExTreeColumnList1AfterUpdateImage(Sender, Node);
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FIBExTreeColumnList1AfterUpdateImage(
      TObject *Sender, TTreeNode *Node)
{
    if (FIBExTreeColumnList1->Images != NULL) {
       if (Node->ImageIndex < ImageComboBox3->Items->Count-1)
          ImageComboBox3->ItemIndex = Node->ImageIndex;
       else
          ImageComboBox3->ItemIndex = -1;
    } else ImageComboBox3->ItemIndex = -1;
    if (FIBExTreeColumnList1->StateImages != NULL) {
       if (Node->StateIndex < ImageComboBox4->Items->Count - 1)
          ImageComboBox4->ItemIndex = Node->StateIndex-1;
       else
          ImageComboBox4->ItemIndex = -1;
    }  else ImageComboBox4->ItemIndex = -1;
    FIBExTreeColumnList1->SetFocus();
}
//---------------------------------------------------------------------------



void __fastcall TF_main::FIBExTreeColumnList1BeforeInsertNode(
      TObject *Sender, TTreeNode *ParentNode, AnsiString &S, int &ImIndex,
      int &StIndex, TStrings *UserParams)
{
//  This You may include user params in empty Strings 'UserParams'
//  for update userfields in you table or view. If UserParams not empty,
//  after insert general fields all included in 'UserParams' UserFields
//  will be updated in database for new record.
//
//  Use format:   UserParams.add('FIELDNAME=VALUE');
//
//  Examples for constant parameters:
//  UserParams.add('FIELDNAME1=''ALEX''');
//  UserParams.add('FIELDNAME2=''01.01.2007''');
//  Examples for variable parameters:
//  UserParams.add(format('FIELDNAME3=''%s''',[STRING_VALUE]));
//  UserParams.add(format('FIELDNAME4=%d',[INTEGER_VALUE]));
//  UserParams.add(formatdatetime('FIELDNAME5=''mm.dd.yyyy''',DATETIME_VALUE));
//  e.t.c
   UserParams->Add("USERTEST='NewUserTest'");        
}
//---------------------------------------------------------------------------

void __fastcall TF_main::TBL_FILTERClick(TObject *Sender)
{
 if (TBL_FILTER->Down)
     try
     {
       TestSelected(FIBExTreeColumnList1->Tree);
       String SelName = FIBExTreeColumnList1->Tree->GetName(FIBExTreeColumnList1->Tree->Selected);
       FIBExTreeColumnList1->Tree->BuildTree(FIBExTreeColumnList1->Tree->GetId(FIBExTreeColumnList1->Tree->Selected));
       ShowMessage("Filter for   "+SelName+
                   "   (FilterID ="+IntToStr(FIBExTreeColumnList1->Tree->FilterID)+")");
     } catch(...){
       TBL_FILTER->Down = False;
       throw;
     }
  else FIBExTreeColumnList1->Tree->BuildTree(0);
  FIBExTreeColumnList1->Tree->SetFocus();
  if (FIBExTreeColumnList1->Tree->Items->Count != 0)
      FIBExTreeColumnList1->Tree->Items->operator[](0)->Selected = True;

}
//---------------------------------------------------------------------------

void __fastcall TF_main::ComboLLevelsChange(TObject *Sender)
{
  FIBExTreeColumnList1->Tree->VisibleLevels = ComboLLevels->ItemIndex;
  FIBExTreeColumnList1->Tree->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::TBL_USERTESTClick(TObject *Sender)
{
//  For update userfields in you table or view you can add
//  params in Strings and call procedure UpdateUserFields
//  (see also event BeforeInsertNode above)
  TestSelected(FIBExTreeColumnList1->Tree);
  String Tmp = FIBExTreeColumnList1->Tree->UserField(FIBExTreeColumnList1->Tree->Selected,"USERTEST");
  String InputString = InputBox("Update field <UserTest>", "Input new text:",Tmp);
  if (InputString != Tmp){
     TStringList *UserParams = new TStringList;
     try {
       UserParams->Add("USERTEST='"+InputString+"'");
       FIBExTreeColumnList1->Tree->UpdateUserFields(FIBExTreeColumnList1->Tree->Selected,UserParams);
     } __finally {
       UserParams->Free();
     }
  }
}
//---------------------------------------------------------------------------

void __fastcall TF_main::UpdateColumnTreeStateCheckButtons(void)
{
  TBC_CHECKALL->Enabled = (FIBExTreeColumnList1->TreeStyle==tsCheckBox);
  TBC_UNCHECKALL->Enabled = (FIBExTreeColumnList1->TreeStyle==tsCheckBox);
}

void __fastcall TF_main::ComboBox8Change(TObject *Sender)
{
  if (ComboBox8 -> Text == "Simple")
      FIBExTreeView1->TreeStyle = tsSimple;
  else
  if (ComboBox8 -> Text == "CheckBox")
      FIBExTreeColumnList1->TreeStyle = tsCheckBox;
  else
      FIBExTreeColumnList1->TreeStyle = tsRadioGroup;
  UpdateColumnTreeStateCheckButtons();
  FIBExTreeColumnList1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::TBC_CHECKALLClick(TObject *Sender)
{
  FIBExTreeColumnList1->Tree->CheckAllNodes();
  FIBExTreeColumnList1->Tree->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::TBC_UNCHECKALLClick(TObject *Sender)
{
  FIBExTreeColumnList1->Tree->UnCheckAllNodes();
  FIBExTreeColumnList1->Tree->SetFocus();
}
//---------------------------------------------------------------------------

// use this event for custom settings !!!

void __fastcall TF_main::FIBExTreeColumnList1GetItemInfo(TObject *Sender,
      TTreeNode *Node, int iColumn, AnsiString &ItemText,
      TColor &ItemColor)
{
  if (CB_CUSTOM_COLOR->Checked)  // custom text attributes
  switch (iColumn) {
  case 1: ItemColor = clBlue;
          break;
  case 2: ItemColor = clGreen;
          break;
  case 3: ItemColor = clRed;
          break;
  case 4: ItemColor = clMaroon;
  }
  if (CB_CUSTOM_TEXT->Checked)  // custom text
  switch (iColumn) {
  case 1: ItemText = "Column 1";
          break;
  case 2: ItemText = "Column 2";
          break;
  case 3: ItemText = "Column 3";
          break;
  case 4: ItemText = "Column 4";
  }
}
//---------------------------------------------------------------------------


void __fastcall TF_main::CB_LINESClick(TObject *Sender)
{
  if (CB_LINES->Checked)
     FIBExTreeColumnList1->Options << clColLines;
  else
     FIBExTreeColumnList1->Options >> clColLines;
  FIBExTreeColumnList1->Invalidate();
}
//---------------------------------------------------------------------------


void __fastcall TF_main::CB_ROWSELECTClick(TObject *Sender)
{
  if (CB_ROWSELECT->Checked)
     FIBExTreeColumnList1->Options << clRowSelect;
  else
     FIBExTreeColumnList1->Options >> clRowSelect;
  FIBExTreeColumnList1->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::CB_CUSTOM_COLORClick(TObject *Sender)
{
  FIBExTreeColumnList1->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::CB_CUSTOM_TEXTClick(TObject *Sender)
{
  FIBExTreeColumnList1->Invalidate();
}
//---------------------------------------------------------------------------

///////////////////////////////////////////////////////////////////////////////
///////////////////////////// Drag & Drop /////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

//---------------------------TreeDropMode----------------------------------

void __fastcall TF_main::ComboBox5Change(TObject *Sender)
{
  if (ComboBox5->ItemIndex == 0) {
     FIBExTreeView2->TreeDropMode = dmRemove;
     FIBExTreeView3->TreeDropMode = dmRemove;
     ComboBox7->ItemIndex = -1;
     ComboBox7->Color = clBtnFace;
     ComboBox7->Enabled = False;
  } else {
     FIBExTreeView2->TreeDropMode = dmCopy;
     FIBExTreeView3->TreeDropMode = dmCopy;
     ComboBox7->ItemIndex = 0;
     ComboBox7->Color = clWindow;
     ComboBox7->Enabled = True;
  }
}
//----------------------------Before DropCopy----------------------------------

void __fastcall TF_main::FIBExTreeView2BeforeDropCopy(TObject *Sender,
      TTreeNode *&NewParent, TTreeCopyMode &Mode, bool &AllowImages,
      bool &AllowCopy)
{
     if (ComboBox6->ItemIndex == 1) NewParent = NULL; // copy to root
     AllowImages = CheckCopyImages->Checked;
     switch (ComboBox7->ItemIndex) {
     case 0:
          Mode = tcmALL;                 // copy selected node with children
          AllowCopy = (MessageDlg("Copy selected node with children?",mtConfirmation,
                               TMsgDlgButtons() << mbOK << mbCancel,0) == mrOk);
          break;
     case 1:
          Mode = tcmChildren;            // copy children of selected node only
          AllowCopy = (MessageDlg("Copy children of selected node?",mtConfirmation,
                               TMsgDlgButtons() << mbOK << mbCancel,0) == mrOk);
          break;
     case 2:
          Mode = tcmNode;                // copy selected node only
          AllowCopy = (MessageDlg("Copy selected node?",mtConfirmation,
                               TMsgDlgButtons() << mbOK << mbCancel,0) == mrOk);
     }
}
//----------------------------Before DropReMove------------------------------

void __fastcall TF_main::FIBExTreeView2BeforeDropRemove(TObject *Sender,
      TTreeNode *&NewParent, bool &AllowImages, bool &AllowRemove)
{
  if (ComboBox6->ItemIndex == 1) NewParent = NULL; // move to root
  AllowImages = CheckCopyImages->Checked;
  AllowRemove = (MessageDlg("Remove selected node?",mtConfirmation,
                               TMsgDlgButtons() << mbOK << mbCancel,0) == mrOk);
}

//////////////////////////////////////////////////////////////////////////////
////////////////////////////// FIBExTreeList /////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

void __fastcall TF_main::FIBExTreeView4Change(TObject *Sender,
      TTreeNode *Node)
{
  if (FIBExTreeList1->FilterID != FIBExTreeView4->GetId(FIBExTreeView4->Selected))
     FIBExTreeList1->BuildList(FIBExTreeView4->GetId(FIBExTreeView4->Selected));
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FIBExTreeList1DblClick(TObject *Sender)
{
  FIBExTreeView4->LocateId(FIBExTreeList1->GetId(FIBExTreeList1->Selected));
  // LocateId call FIBExTreeView4Change (see above)
  if (FIBExTreeView4->Selected != NULL) FIBExTreeView4->Selected->Expand(false);
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FIBExTreeList1BeforeDeleteItem(TObject *Sender,
      TListItem *Item, bool &AllowDelete)
{
  AllowDelete = (MessageDlg("Delete selected item?",mtConfirmation,
                               TMsgDlgButtons() << mbOK << mbCancel,0) == mrOk);
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FIBExTreeList1AfterUpdateImage(TObject *Sender,
      TListItem *Item)
{
  if (FIBExTreeView4->Selected != NULL) {
     if (!FIBExTreeView4->Selected->HasChildren)
        FIBExTreeView4->RefreshNode(FIBExTreeView4->Selected);
     FIBExTreeView4->Selected->Expand(false);
  } else FIBExTreeView4->BuildTree(0);
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FIBExTreeList1AfterDeleteItem(TObject *Sender)
{
  FIBExTreeList1AfterUpdateImage(Sender,NULL);
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FIBExTreeList1AfterInsertItem(TObject *Sender,
      TListItem *Item)
{
  if (FIBExTreeView4->Selected != NULL) {
     if (! FIBExTreeView4->Selected->HasChildren)
        FIBExTreeView4->RefreshNode(FIBExTreeView4->Selected);
     FIBExTreeView4->Selected->Expand(false);
  } else FIBExTreeView4->BuildTree(0);
}
//---------------------------------------------------------------------------


void __fastcall TF_main::FIBExTreeList1BeforeInsertItem(TObject *Sender,
      AnsiString &S, int &ImIndex, int &StIndex)
{
  // You may set own Caption, ImageIndex and StateIndex here        
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FIBExTreeList1AfterExchangeItem(TObject *Sender,
      TListItem *Item)
{
  if (FIBExTreeView4->Selected) {
     if (!FIBExTreeView4->Selected->HasChildren)
          FIBExTreeView4->RefreshNode(FIBExTreeView4->Selected);
     FIBExTreeView4->Selected->Expand(false);
  } else FIBExTreeView4->BuildTree(0);
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FIBExTreeList1AfterSortItems(TObject *Sender)
{
  FIBExTreeList1AfterUpdateImage(Sender,NULL);
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FIBExTreeList1AfterLocateItem(TObject *Sender,
      TListItem *Item)
{
  FIBExTreeView4->LocateId(FIBExTreeList1->FilterID);
}
//---------------------------------------------------------------------------

void __fastcall TF_main::TB_LARGEClick(TObject *Sender)
{
  if (Sender == TB_LARGE)
     FIBExTreeList1->ViewStyle = vsIcon;
  else
  if (Sender == TB_SMALL)
     FIBExTreeList1->ViewStyle = vsSmallIcon;
  else
  if (Sender == TB_LIST)
     FIBExTreeList1->ViewStyle = vsList;
  else
  if (Sender == TB_REPORT)
     FIBExTreeList1->ViewStyle = vsReport;
  else
  if (Sender == TB_BACK) {
     if (FIBExTreeView4->Selected != NULL)
       if (FIBExTreeView4->Selected->Parent == NULL) {
          FIBExTreeView4->Selected->Collapse(true);
          FIBExTreeView4->Selected->Selected = false;
          FIBExTreeList1->BuildList(0);
       } else {
          FIBExTreeView4->Selected->Collapse(false);
          FIBExTreeView4->LocateId(FIBExTreeView4->GetParentId(FIBExTreeView4->Selected));
          // LocateId call FIBExTreeView4Change (see above)
       }
     /////////////////////////////////////////////////////
     // see also methot TFIBExTreeList.BuildParentList; //
     /////////////////////////////////////////////////////
  }
}
//---------------------------------------------------------------------------

void __fastcall TF_main::UpdateListStateCheckButtons(void)
{
  TBL_CHECKALL->Enabled = (FIBExTreeList1->TreeListStyle == lsCheckBox);
  TBL_UNCHECKALL->Enabled =(FIBExTreeList1->TreeListStyle == lsCheckBox);
}

void __fastcall TF_main::ComboBox3Change(TObject *Sender)
{
  if (ComboBox3->Text == "Simple")
     FIBExTreeList1->TreeListStyle = lsSimple;
  else
  if (ComboBox3->Text == "CheckBox")
     FIBExTreeList1->TreeListStyle = lsCheckBox;
  else
  if (ComboBox3->Text == "RadioGroup")
     FIBExTreeList1->TreeListStyle = lsRadioGroup;
  UpdateListStateCheckButtons();
  FIBExTreeList1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::ComboBox4Change(TObject *Sender)
{
  if (FIBExTreeList1->TreeListStyle != lsSimple) FIBExTreeList1->RefreshList();
  UpdateListStateCheckButtons();
  FIBExTreeList1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::TBL_CHECKALLClick(TObject *Sender)
{
  FIBExTreeList1->CheckAllItems();
  FIBExTreeList1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::TBL_UNCHECKALLClick(TObject *Sender)
{
  FIBExTreeList1->UnCheckAllItems();
  FIBExTreeList1->SetFocus();
}
//---------------------------------------------------------------------------

//////////////////////////////////////////////////////////////////////////////
//////////////////////////// FIBExTreeComboBox ///////////////////////////////
//////////////////////////////////////////////////////////////////////////////

void __fastcall TF_main::FIBExTreeView4BeforeDeleteNode(TObject *Sender,
      TTreeNode *Node, bool &AllowDelete)
{
  AllowDelete = (MessageDlg("Delete selected item?",mtConfirmation,
                             TMsgDlgButtons() << mbOK << mbCancel,0) == mrOk);
}
//---------------------------------------------------------------------------


//---------------------------set KeyValue----------------------------------

void __fastcall TF_main::Button1Click(TObject *Sender)
{
  FIBExTreeComboBox1->KeyValue = FIBExTreeView5->GetId(FIBExTreeView5->Selected);
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FIBExTreeComboBox1ChangeKeyValue(TObject *Sender)
{
  Label3->Caption = "KeyValue = " + IntToStr(FIBExTreeComboBox1->KeyValue);
}
//-----------------------------CharCase----------------------------------------

void __fastcall TF_main::RadioGroup1Click(TObject *Sender)
{
  switch (RadioGroup1->ItemIndex){
    case 0: FIBExTreeComboBox1->CharCase = ecLowerCase;
    case 1: FIBExTreeComboBox1->CharCase = ecNormal;
    case 2: FIBExTreeComboBox1->CharCase = ecUpperCase;
  }
}
//-------------------------ShowFullExpanded------------------------------

void __fastcall TF_main::CheckBox1Click(TObject *Sender)
{
  FIBExTreeComboBox1->TreePopupOptions->ShowFullExpanded = CheckBox1->Checked;
}
//--------------------------ShowLastSize-----------------------------------

void __fastcall TF_main::CheckBox4Click(TObject *Sender)
{
  FIBExTreeComboBox1->TreePopupOptions->ShowLastSize = CheckBox4->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TF_main::ComboBLevelsChange(TObject *Sender)
{
  FIBExTreeComboBox1->VisibleLevels = ComboBLevels->ItemIndex;
  FIBExTreeComboBox1->SetFocus();
}

//--------------------------TreeFilterID-----------------------------

void __fastcall TF_main::CheckBox2Click(TObject *Sender)
{
  if (CheckBox2->Checked){
     if (FIBExTreeView5->Selected == NULL) {
        CheckBox2->Checked = False;
        throw("Not assigned FIBExTreeView5.Selected!");
     }
     FIBExTreeComboBox1->TreeFilterID =
     FIBExTreeView5->GetId(FIBExTreeView5->Selected);
  } else FIBExTreeComboBox1->TreeFilterID = 0;
}
//---------------------------------------------------------------------------

void __fastcall TF_main::ComboCFilterChange(TObject *Sender)
{
  switch (ComboCFilter->ItemIndex){
    case 0: FIBExTreeComboBox1->Filtered = False;
            break;
    case 1: FIBExTreeComboBox1->Filter = "NAME starting with '"+Trim(E_CFILTER->Text)+"'";
            if (! FIBExTreeComboBox1->Filtered) FIBExTreeComboBox1->Filtered = True;
            break;
    case 2: FIBExTreeComboBox1->Filter = "NAME containing '"+Trim(E_CFILTER->Text)+"'";
            if (! FIBExTreeComboBox1->Filtered) FIBExTreeComboBox1->Filtered = True;
  }
  // Note: If property Filtered == True and property Filter is not empty and was changed or
  //       property Filter is not empty and property Filtered was changed to true then
  //       TreeView will be rebuild automatically!
}
//---------------------------------------------------------------------------

void __fastcall TF_main::E_CFILTERKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  if ((Key == VK_RETURN) && FIBExTreeComboBox1->Filtered) ComboFilterChange(0);
}

//-----------------------------EnterAsTab---------------------------------

void __fastcall TF_main::CheckBox3Click(TObject *Sender)
{
  FIBExTreeComboBox1->EnterAsTab = CheckBox3->Checked;
}
//-----------------------------TextAsPath--------------------------------

void __fastcall TF_main::CheckBox5Click(TObject *Sender)
{
  FIBExTreeComboBox1->TextAsPath = CheckBox5->Checked;
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////// Master - Detail /////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

void __fastcall TF_main::CheckBox6Click(TObject *Sender)
{
  if (FIBExTreeView6->Selected != NULL)
     FIBExTreeView6Change(NULL,FIBExTreeView6->Selected);
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FIBExTreeView6Change(TObject *Sender,
      TTreeNode *Node)
{
  if (!B_CREATEDATA->Visible && IBD->Connected && Node != NULL){
     if (IBDataSet1->Active) IBDataSet1->Close();
     if (!CheckBox6->Checked) {
        IBDataSet1->SelectSQL->Text = "select * from TABLE_DETAIL where ID_TREE = :ID order by ID";
        IBDataSet1->ParamByName("ID")->AsInteger = FIBExTreeView6->GetId(Node);
     } else {
        IBDataSet1->SelectSQL->Text = "select D.* from TABLE_DETAIL D, OBJECTS O where \
                                      D.ID_TREE = O.ID and O.FullPath like :FP \
                                      order by D.ID,D.ID_TREE";
        IBDataSet1->ParamByName("FP")->AsString = FIBExTreeView6->GetFullPath(Node)+"%";
     }
     IBDataSet1->Open();
  }
}
//---------------------------------------------------------------------------

void __fastcall TF_main::B_CREATEDATAClick(TObject *Sender)
{
  if (!IBD->Connected) return;
  if (IBDataSet1->Active) IBDataSet1->Close();
  TpFIBQuery* IBSQL1;
  TpFIBQuery* IBSQL2;
  Screen->Cursor = crSQLWait;
  try {
    IBSQL1 = new TpFIBQuery(NULL);
    IBSQL2 = new TpFIBQuery(NULL);
    IBSQL1->Database = IBD;
    IBSQL2->Database = IBD;
    IBSQL1->Transaction = Tr_Read;
    IBSQL2->Transaction = Tr_Write;
    if (! Tr_Read->InTransaction) Tr_Read->StartTransaction();
    if (! Tr_Write->InTransaction) Tr_Write->StartTransaction();
    try {
      IBSQL2->SQL->Text = "delete from TABLE_DETAIL";
      IBSQL2->ExecQuery();
      IBSQL2->Close();
      IBSQL2->SQL->Text = "insert into TABLE_DETAIL(ID,ID_TREE,DETAIL) \
                           values(:ID,:ID_TREE,:DETAIL)";
      IBSQL2->Prepare();
      IBSQL1->SQL->Text = "select ID from SORT_OBJECTS(0)";
      IBSQL1->ExecQuery();
      int GEN_ID = 0;
      while (!IBSQL1->Eof) {
        for (int GEN_DETAIL = 1; GEN_DETAIL < 4; GEN_DETAIL++) {
            GEN_ID++;
            IBSQL2->ParamByName("ID")->AsInteger = GEN_ID;
            IBSQL2->ParamByName("ID_TREE")->AsInteger = IBSQL1->Fields[0]->AsInteger;
            IBSQL2->ParamByName("DETAIL")->AsString = "Detail "+IntToStr(GEN_DETAIL);
            IBSQL2->ExecQuery();
        }
        IBSQL1->Next();
      }
      Tr_Write->Commit();
      B_CREATEDATA->Visible = False;
      Application->ProcessMessages();
      CheckBox6Click(NULL);
    } catch (...){
      Tr_Write->Rollback();
      throw;
    }
  } __finally {
    if (IBSQL1 != NULL) IBSQL1->Free();
    if (IBSQL2 != NULL) IBSQL2->Free();
    Screen->Cursor = crDefault;
  }
}

//---------------------------------------------------------------------------

void __fastcall TF_main::TB_LOCATEClick(TObject *Sender)
{
  F_locate->ShowModal();
}

/////////////////////////////////////////////////////////////////////////////
////////////////////////////// dynamic //////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

void __fastcall TF_main::PageDynControlChange(TObject *Sender)
{
  TDynLevels *Levels;

  CB_Levels->Enabled = True;
  CB_Reload->Enabled = True;
  RLevel0->Enabled = True;
  RLevel1->Enabled = True;
  RLevel2->Enabled = True;

  switch (PageDynControl->ActivePageIndex) {
  case 0: Levels = FIBExDynTreeView1->Levels;
          CB_Levels->ItemIndex = FIBExDynTreeView1->VisibleLevels;
          CB_Reload->Checked = FIBExDynTreeView1->ReloadNodesOnExpand;
          break;
  case 1: Levels = FIBExDynTreeColumnList1->Levels;
          CB_Levels->ItemIndex = FIBExDynTreeColumnList1->VisibleLevels;
          CB_Reload->Checked = FIBExDynTreeColumnList1->ReloadNodesOnExpand;
          break;
  case 2: Levels = FIBExDynTreeList1->Levels;
          CB_Levels->Enabled=False;
          CB_Reload->Enabled=False;
          break;
  case 3: Levels=FIBExDynTreeComboBox1->Levels;
          CB_Levels->ItemIndex=FIBExDynTreeComboBox1->VisibleLevels;
          CB_Reload->Checked=FIBExDynTreeComboBox1->ReloadNodesOnExpand;
          RLevel0->Enabled = False;
          RLevel1->Enabled = False;
          RLevel2->Enabled = False;
          break;
  default: exit(0);
  }
  DisableRG = True;
  try
  {
    switch ((*Levels)[0]->LevelStyle) {
    case lvsSimple:     RLevel0->ItemIndex=0; break;
    case lvsCheckBox:   RLevel0->ItemIndex=1; break;
    case lvsRadioGroup: RLevel0->ItemIndex=2;
    }
    switch ((*Levels)[1]->LevelStyle) {
    case lvsSimple:     RLevel1->ItemIndex=0; break;
    case lvsCheckBox:   RLevel1->ItemIndex=1; break;
    case lvsRadioGroup: RLevel1->ItemIndex=2;
    }
    switch ((*Levels)[2]->LevelStyle) {
    case lvsSimple:     RLevel2->ItemIndex=0; break;
    case lvsCheckBox:   RLevel2->ItemIndex=1; break;
    case lvsRadioGroup: RLevel2->ItemIndex=2;
    }
  }
  __finally
  {
    DisableRG = False;
  }
  if ((PageDynControl->ActivePageIndex != 2) &&
      ((*Levels)[0]->LevelStyle == lvsSimple) &&
      ((*Levels)[1]->LevelStyle == lvsSimple) &&
      ((*Levels)[2]->LevelStyle == lvsSimple))
      CB_Reload->Enabled = True;
  else
      CB_Reload->Enabled = False;

  switch (PageDynControl->ActivePageIndex) {
  case 0: if (FIBExDynTreeView1->Items->Count == 0) FIBExDynTreeView1->BuildTree();
  case 1: if (FIBExDynTreeColumnList1->Tree->Items->Count == 0) FIBExDynTreeColumnList1->Tree->BuildTree();
  case 2: if (FIBExDynTreeList1->Items->Count == 0) FIBExDynTreeList1->BuildList(NULL);
  }        
}

//---------------------------------------------------------------------------

void __fastcall TF_main::ChangeLevelStyle(void)
{
  if (DisableRG) return;

  TDynLevels *Levels;

  switch (PageDynControl->ActivePageIndex) {
  case 0: Levels = FIBExDynTreeView1->Levels;
          FIBExDynTreeView1->VisibleLevels = CB_Levels->ItemIndex;
          FIBExDynTreeView1->ReloadNodesOnExpand = False;
          break;
  case 1: Levels = FIBExDynTreeColumnList1->Levels;
          FIBExDynTreeColumnList1->VisibleLevels = CB_Levels->ItemIndex;
          FIBExDynTreeColumnList1->ReloadNodesOnExpand = False;
          break;
  case 2: Levels = FIBExDynTreeList1->Levels;
          break;
  case 3: Levels = FIBExDynTreeComboBox1->Levels;
          FIBExDynTreeComboBox1->VisibleLevels = CB_Levels->ItemIndex;
          FIBExDynTreeComboBox1->ReloadNodesOnExpand = False;
          break;
  default: exit(0);
  }
  switch (RLevel0->ItemIndex){
  case 0: (*Levels)[0]->LevelStyle=lvsSimple;     break;
  case 1: (*Levels)[0]->LevelStyle=lvsCheckBox;   break;
  case 2: (*Levels)[0]->LevelStyle=lvsRadioGroup;
  }
  switch (RLevel1->ItemIndex){
  case 0: (*Levels)[1]->LevelStyle=lvsSimple;     break;
  case 1: (*Levels)[1]->LevelStyle=lvsCheckBox;   break;
  case 2: (*Levels)[1]->LevelStyle=lvsRadioGroup;
  }
  switch (RLevel2->ItemIndex){
  case 0: (*Levels)[2]->LevelStyle=lvsSimple;     break;
  case 1: (*Levels)[2]->LevelStyle=lvsCheckBox;   break;
  case 2: (*Levels)[2]->LevelStyle=lvsRadioGroup;
  }
  if ((PageDynControl->ActivePageIndex != 2) &&
      ((*Levels)[0]->LevelStyle == lvsSimple) &&
      ((*Levels)[1]->LevelStyle == lvsSimple) &&
      ((*Levels)[2]->LevelStyle == lvsSimple))
     CB_Reload->Enabled=True;
  else {
     CB_Reload->Enabled=False;
     CB_Reload->Checked=False;
  }
  switch (PageDynControl->ActivePageIndex) {
  case 0: FIBExDynTreeView1->ReloadNodesOnExpand=CB_Reload->Checked;
          FIBExDynTreeView1->BuildTree();
          break;
  case 1: FIBExDynTreeColumnList1->ReloadNodesOnExpand=CB_Reload->Checked;
          FIBExDynTreeColumnList1->Tree->BuildTree();
          break;
  case 2: FIBExDynTreeList1->RefreshList();
          break;
  case 3: FIBExDynTreeComboBox1->ReloadNodesOnExpand=CB_Reload->Checked;
  }
}

//---------------------------------------------------------------------------

void __fastcall TF_main::TB_DBACKClick(TObject *Sender)
{
  if (dynamic_cast<TToolButton *>(Sender) == TB_DBACK)
     FIBExDynTreeList1->BuildParentList();
  else {
    if (dynamic_cast<TToolButton *>(Sender) == TB_DLARGE)
       FIBExDynTreeList1->ViewStyle=vsIcon;
    else
    if (dynamic_cast<TToolButton *>(Sender) == TB_DSMALL)
       FIBExDynTreeList1->ViewStyle=vsSmallIcon;
    else
    if (dynamic_cast<TToolButton *>(Sender) == TB_DLIST)
       FIBExDynTreeList1->ViewStyle=vsList;
    else
    if (dynamic_cast<TToolButton *>(Sender) == TB_DREPORT)
       FIBExDynTreeList1->ViewStyle=vsReport;
  }        
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FIBExDynTreeList1DblClick(TObject *Sender)
{
  if (FIBExDynTreeList1->Selected != NULL)
  FIBExDynTreeList1->BuildList(FIBExDynTreeList1->Selected);        
}
//---------------------------------------------------------------------------

void __fastcall TF_main::RG_COMBO1Click(TObject *Sender)
{
  switch (RG_COMBO1->ItemIndex) {
  case 0: FIBExDynTreeComboBox1->CharCase=ecLowerCase;
  case 1: FIBExDynTreeComboBox1->CharCase=ecNormal;
  case 2: FIBExDynTreeComboBox1->CharCase=ecUpperCase;
  }
}
//---------------------------------------------------------------------------

void __fastcall TF_main::CB_DFEXClick(TObject *Sender)
{
  FIBExDynTreeComboBox1->TreePopupOptions->ShowFullExpanded=CB_DFEX->Checked;        
}
//---------------------------------------------------------------------------

void __fastcall TF_main::CB_DSLSClick(TObject *Sender)
{
  FIBExDynTreeComboBox1->TreePopupOptions->ShowLastSize=CB_DSLS->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FIBExDynTreeComboBox1CloseUp(TObject *Sender,
      bool Selected)
{
  Memo_key->Clear();
  for (int i = 0; i < FIBExDynTreeComboBox1->KeyList->Count; i++)
      Memo_key->Lines->Add("Level"+IntToStr(i)+":  ID = "+
      (*FIBExDynTreeComboBox1->KeyList)[i]->KeyValue("ID"));        
}
//---------------------------------------------------------------------------

void __fastcall TF_main::RLevel0Click(TObject *Sender)
{
  ChangeLevelStyle();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FIBExDynTreeView1GetSelectSql(TObject *Sender,
      TTreeNode *ParentNode, TStrings *SelectSql)
{

  int LIndex;

  if (ParentNode == NULL)
     LIndex=0;
  else
     LIndex=ParentNode->Level+1;
  LSQL->Caption = "SelectSql-> Level: " + IntToStr(LIndex);
  Memo_sql->Lines->Text=SelectSql->Text;
  /*
   This You may to set custom sql params
   with use propertyes ParamByName or Params if need.
   Note: Don`t set params for parent relation key fields this.
   It`s will be automatically if params names equal fields names
   from parent sql result set!
  */
}

//---------------------------------------------------------------------------

void __fastcall TF_main::FIBExDynTreeList1GetSelectSql(TObject *Sender,
      int LevelIndex, TStrings *SelectSql)
{
  LSQL->Caption = "SelectSql-> Level: " + IntToStr(LevelIndex);
  Memo_sql->Lines->Text=SelectSql->Text;
  /*
   This You may to set custom sql params
   with use propertyes ParamByName or Params if need.
   Note: Don`t set params for parent relation key fields this.
   It`s will be automatically if params names equal fields names
   from parent sql result set!
  */
}
//---------------------------------------------------------------------------

void __fastcall TF_main::CB_DLINESClick(TObject *Sender)
{
  if (CB_DLINES->Checked)
     FIBExDynTreeColumnList1->Options << clColLines;
  else
     FIBExDynTreeColumnList1->Options >> clColLines;
  FIBExDynTreeColumnList1->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::CB_DROWSELECTClick(TObject *Sender)
{
  if (CB_DROWSELECT->Checked)
     FIBExDynTreeColumnList1->Options << clRowSelect;
  else
     FIBExDynTreeColumnList1->Options >> clRowSelect;
  FIBExDynTreeColumnList1->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::CB_DCUSTOM_COLORClick(TObject *Sender)
{
   FIBExDynTreeColumnList1->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::CB_DCUSTOM_TEXTClick(TObject *Sender)
{
   FIBExDynTreeColumnList1->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FIBExDynTreeColumnList1GetItemInfo(
      TObject *Sender, TTreeNode *Node, int iColumn, AnsiString &ItemText,
      TColor &ItemColor)
{
  if (CB_DCUSTOM_COLOR->Checked)  // custom text attributes
  switch (iColumn) {
  case 1: ItemColor = clBlue;
          break;
  case 2: ItemColor = clGreen;
          break;
  }
  if (CB_DCUSTOM_TEXT->Checked)  // custom text
  switch (iColumn) {
  case 1: ItemText = "Column 1";
          break;
  case 2: ItemText = "Column 2";
          break;
  }
}

//---------------------------------------------------------------------------
void __fastcall TF_main::CheckBox8Click(TObject *Sender)
{
  FIBExDynTreeComboBox1->ClickLastLevelOnly=CheckBox8->Checked;
}

//---------------------------------------------------------------------------

void __fastcall TF_main::About1Click(TObject *Sender)
{
  AboutBox->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::English1Click(TObject *Sender)
{
  AnsiString TEST;
  AnsiString PATH = AnsiUpperCase(ExtractFilePath(Application->ExeName));
  if (Sender == English1)
     TEST = "HELP\\ENG\\FIBExTREES.HLP";
  else
     TEST = "HELP\\RUS\\FIBExTREES.HLP";
  int poz = PATH.Pos("DEMO");
  PATH = PATH.SubString(1,poz-1);
  Application->HelpFile = PATH + TEST;
  Application->HelpCommand(HELP_FINDER, 0);
}



