unit u_sortlist;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Dialogs;

type
  TF_sortlist = class(TForm)
    ListBox1: TListBox;
    Panel2: TPanel;
    SB_TOP: TSpeedButton;
    SB_BOTTOM: TSpeedButton;
    OKBtn: TButton;
    CancelBtn: TButton;
    procedure ListBox1Click(Sender: TObject);
    procedure SB_TOPClick(Sender: TObject);
    procedure SB_BOTTOMClick(Sender: TObject);
    procedure ListBox1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ListBox1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure FormShow(Sender: TObject);
  private
    procedure RestoreButtons;
  public
    { Public declarations }
  end;

var
  F_sortlist: TF_sortlist;

implementation

{$R *.DFM}

procedure TF_sortlist.RestoreButtons;
begin
  SB_TOP.Enabled:=(ListBox1.Items.Count > 1) and (ListBox1.ItemIndex > 0);
  SB_BOTTOM.Enabled:=(ListBox1.ItemIndex > -1) and
                     (ListBox1.ItemIndex < (ListBox1.Items.Count - 1))
                      and (ListBox1.Items.Count > 1);
end;

procedure TF_sortlist.ListBox1Click(Sender: TObject);
begin
  RestoreButtons;
end;

procedure TF_sortlist.SB_TOPClick(Sender: TObject);
begin
  if ListBox1.ItemIndex = 0 then exit;
  ListBox1.Items.Exchange(ListBox1.ItemIndex,ListBox1.ItemIndex-1);
  RestoreButtons;
end;

procedure TF_sortlist.SB_BOTTOMClick(Sender: TObject);
begin
  if ListBox1.ItemIndex = (ListBox1.Items.Count-1) then exit;
  ListBox1.Items.Exchange(ListBox1.ItemIndex,ListBox1.ItemIndex+1);
  RestoreButtons;
end;

procedure TF_sortlist.ListBox1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := (Sender=Source);
end;

procedure TF_sortlist.ListBox1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
var NewIndex: Integer;
begin
  with (Sender as TListBox) do begin
    NewIndex:=ItemAtPos(Point(x,y),True);
    Items.Move(ItemIndex, NewIndex);
    if NewIndex = -1 then NewIndex:=Items.Count-1;
    ItemIndex:=NewIndex;
  end;
  RestoreButtons;
end;

procedure TF_sortlist.FormShow(Sender: TObject);
begin
  RestoreButtons;
end;

end.
